OAuth JWT Bearer Authorization app
===========================================

Allows connecting to Salesforce using OAuth 2.0 JWT Bearer Token Flow

Installation and Usage
----------------------

1. Import the demo project into your workspace
2. Go to <workspace>/oauth-jwt-bearer-auth-app
3. Open a command prompt/terminal
4. Type "keytool -genkeypair -alias salesforce-cert -keyalg RSA -keystore src/main/resources/salesforce-cert.jks" and hit enter. 
    4.1. You will be asked for a password for you key store file, so type one, hit enter and keep it in mind.

    4.2. You will be asked for your first and last name, so type them and hit enter.

    4.3. You will be asked for your organization unit, so type one and hit enter. (ex: "QA")

    4.4. You will be asked for your organization, so type one and hit enter. (ex: "JWT TEST")

    4.5. You will be asked for your city, so type it and hit enter.

    4.6. You will be asked for your state, so type it and hit enter.

    4.7. You will be asked for your country's two letters code, so type it and hit enter.

5. The command from previous step will generate a java key store file containing a private/public key pair within "<workspace>/oauth-jwt-bearer-auth-app/src/main/resources". This file has to be kept safe.

6. Type `keytool -exportcert -alias salesforce-cert -file src/main/resources/salesforce-cert.crt -keystore src/main/resources/salesforce-cert.jks` and hit enter.

7. The command from previous step will export the public key from keystore into "<workspace>/oauth-jwt-bearer-auth-app/src/main/resources". This is the public key that has to be uploaded into salesforce and that will help Salesforce to identify you.

8. Check that you have both keysotre (salesforce-cert.jks) and public key (salesforce-cert.crt) files within "<workspace>/oauth-jwt-bearer-auth-app/src/main/resources".

9. Login into salesforce system.

10. Go to: Setup -> Build -> Create -> Apps

11. Under "Connected App" section click "New" button

12. Fill fields as below:

    12.1. For "Connected App Name" type "JWT test".

    12.2. For "API name" type "JWT_test".

    12.3. For "Contact email" type your email.

    12.4. Under "API (Enable OAuth Settings)" check "Enable OAuth Settings". Few other fields will show up.

    12.5. For "Callback URL" type "https://localhost:8081/callback".

    12.6. Check "Use digital signatures" checkbox.

    12.7. Click "Browse..." and navigate to "<workspace>/oauth-jwt-bearer-auth-app/src/main/resources", select "salesforce-cert.crt" then click "Open".

    12.8. For "Selected OAuth Scopes" move from left to right "Full access (full)" and "Perform requests on your behalf at any time (refresh\_token, offline\_access)".

    12.9. Now your done and you can scroll down and click "Save".

    12.10. Click "Continue".

13. Click "Manage".

14. Click "Edit".

15. Under "OAuth policies" select from drop down "Admin approved users are pre-authorized" for "Permitted Users".

16. Click "Save".

17. Under "Profiles" section click "Manage Profiles".

18. From the list check your user's profile (ex: "Standard User").

19. Click "Save".

20. Now go back to your connected app Build -> Create -> Apps, under "Connected Apps" select "JWT test".

21. Copy "Consumer key" and fill value of salesforce.consumerKey from <workspace>/oauth-jwt-bearer-auth-app/src/main/app/mule-app.properties file with copied value.

22. Fill value of salesforce.principal with your salesforce user.

23. Fill value of keystore.password with password that you have set with step 4.1.

24. Run the project in Studio.

25. Run the demo project and with in the browser hit `http://localhost:8081`

26. Press Get User Info to get the user Info.

For more information on how "OAuth 2.0 JWT Bearer Token Flow" works in salesforce see: [OAuth 2.0 JWT Bearer Token Flow](https://help.salesforce.com/HTViewHelpDoc?id=remoteaccess_oauth_jwt_flow.htm&language=en_US). 
For more information on "Connected Apps" see [Connected Apps Overview](https://help.salesforce.com/apex/HTViewHelpDoc?id=connected_app_overview.htm&language=en_US).